var Generator = require('yeoman-generator');
const glob = require('glob')

module.exports = class extends Generator {
    async prompting() {
        const answers = await this.prompt([
            {
                type: "input",
                name: "projectName",
                message: "The project name must be the same for all services/repositories"
            },
            {
                type: "input",
                name: "gcrUrl",
                message: "GCR link (where you store your images)",
                default: "936412892777.dkr.ecr.eu-central-1.amazonaws.com"
            },
            {
                type: "input",
                name: "stagingDomain",
                message: "Your staging domain",
                default: `${this.appname}.btn.fyi`
            },
        ]);
        this.answers = answers;
    }

    async writing() {
        this.destinationRoot("./")
        const root = this.templatePath('./')
        const files = glob.sync('**', {dot: true, nodir: true, cwd: root})
        const filesRemapping = {
            "envs-configmap.yml": `${this.answers.projectName}-envs-configmap.yml`,
        }
        for (let i in files) {
            const inputFile = files[i]
            let outputFile = files[i]
            if (filesRemapping[inputFile]) {
                outputFile = filesRemapping[inputFile]
            }
            this.fs.copyTpl(
                this.templatePath(`./${inputFile}`),
                this.destinationPath(outputFile),
                this.answers
            )
        }
    }
};
